# DataDistribution Class Reference

`#include <DataDistribution.hh>`

List of all members.

## Public Member Functions
| DataDistribution (RootObject *, FederationManagement *, Communications *)
SpaceHandle | getRoutingSpaceHandle (std::string) const
std::string | getRoutingSpaceName (SpaceHandle) const
DimensionHandle | getDimensionHandle (std::string, SpaceHandle) const throw (SpaceNotDefined, NameNotFound)
std::string | getDimensionName (DimensionHandle, SpaceHandle) const throw (SpaceNotDefined, DimensionNotDefined)
SpaceHandle | getAttributeSpace (AttributeHandle, ObjectClassHandle) const throw (ObjectClassNotDefined, AttributeNotDefined)
SpaceHandle | getInteractionSpace (InteractionClassHandle) const throw (InteractionClassNotDefined)
long | createRegion (SpaceHandle, unsigned long, TypeException &) throw (SpaceNotDefined)
void | modifyRegion (RegionHandle, const std::vector< Extent > &, TypeException &)
void | deleteRegion (long, TypeException &) throw (RegionNotKnown, RegionInUse)
void | associateRegion (ObjectHandle, RegionHandle, std::vector< AttributeHandle > &, int, TypeException &) throw (RegionNotKnown)
ObjectHandle | registerObject (ObjectClassHandle, const std::string, const std::vector< AttributeHandle > &, int, const std::vector< RegionHandle >, TypeException &)
void | unassociateRegion (ObjectHandle, RegionHandle, TypeException &e) throw (ObjectNotKnown, InvalidRegionContext, RegionNotKnown)
void | subscribe (ObjectClassHandle, RegionHandle, std::vector< AttributeHandle > &, int, TypeException &) throw (RegionNotKnown)
void | unsubscribeAttributes (ObjectClassHandle, RegionHandle, TypeException &) throw (RegionNotKnown)
void | subscribeInteraction (InteractionClassHandle, RegionHandle, TypeException &) throw (RegionNotKnown)
void | unsubscribeInteraction (InteractionClassHandle, RegionHandle, TypeException &) throw (RegionNotKnown)
## Private Attributes
RootObject * | rootObject
FederationManagement * | fm
Communications * | comm

## Detailed Description

Definition at line 35 of file DataDistribution.hh.

## Constructor & Destructor Documentation

DataDistribution | ( | RootObject * | root_object,
|  | FederationManagement * | fed_management,
|  | Communications * | communications |
| ) |  |  |

Definition at line 50 of file DataDistribution.cc.

## Member Function Documentation

SpaceHandle getRoutingSpaceHandle | ( | std::string | name | ) | const

Definition at line 59 of file DataDistribution.cc.

References RootObject::getRoutingSpaceHandle(), and DataDistribution::rootObject.

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

string getRoutingSpaceName | ( | SpaceHandle | handle | ) | const

Definition at line 68 of file DataDistribution.cc.

References RootObject::getRoutingSpaceName(), and DataDistribution::rootObject.

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

DimensionHandle getDimensionHandle | ( | std::string | dimension,
|  | SpaceHandle | space |
| ) |  |  | const throw (SpaceNotDefined, NameNotFound)

Definition at line 77 of file DataDistribution.cc.

References RoutingSpace::getDimensionHandle(), RootObject::getRoutingSpace(), and DataDistribution::rootObject.

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

string getDimensionName | ( | DimensionHandle | dimension,
|  | SpaceHandle | space |
| ) |  |  | const throw (SpaceNotDefined, DimensionNotDefined)

Definition at line 87 of file DataDistribution.cc.

References RoutingSpace::getDimensionName(), RootObject::getRoutingSpace(), and DataDistribution::rootObject.

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

SpaceHandle getAttributeSpace | ( | AttributeHandle | attribute,
|  | ObjectClassHandle | object_class |
| ) |  |  | const throw (ObjectClassNotDefined, AttributeNotDefined)

Definition at line 98 of file DataDistribution.cc.

References certi::fedparser::attribute, TreeNamedAndHandledSet::getObjectFromHandle(), RootObject::ObjectClasses, and DataDistribution::rootObject.

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

SpaceHandle getInteractionSpace | ( | InteractionClassHandle | interaction | ) | const throw (InteractionClassNotDefined)

Definition at line 111 of file DataDistribution.cc.

References TreeNamedAndHandledSet::getObjectFromHandle(), RootObject::Interactions, and DataDistribution::rootObject.

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

long createRegion | ( | SpaceHandle | space,
|  | unsigned long | nb_extents,
|  | TypeException & | e |
| ) |  |  | throw (SpaceNotDefined)

Definition at line 121 of file DataDistribution.cc.

References FederationManagement::_numero_federation, RootObject::addRegion(), DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_CREATE_REGION, certi::e_NO_EXCEPTION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, BaseRegion::getNumberOfExtents(), RootObject::getRoutingSpace(), NetworkMessage::nbExtents, pdDebug, DataDistribution::rootObject, Communications::sendMessage(), NetworkMessage::space, and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void modifyRegion | ( | RegionHandle | handle,
|  | const std::vector< Extent > & | extents,
|  | TypeException & | e |
| ) |  |  |

Definition at line 157 of file DataDistribution.cc.

References FederationManagement::_numero_federation, DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_MODIFY_REGION, certi::e_NO_EXCEPTION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, RootObject::getRegion(), pdDebug, NetworkMessage::region, BaseRegion::replaceExtents(), DataDistribution::rootObject, Communications::sendMessage(), BasicMessage::setExtents(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void deleteRegion | ( | long | handle,
|  | TypeException & | e |
| ) |  |  | throw (RegionNotKnown, RegionInUse)

Definition at line 188 of file DataDistribution.cc.

References FederationManagement::_numero_federation, DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_DELETE_REGION, RootObject::deleteRegion(), certi::e_NO_EXCEPTION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, RootObject::getRegion(), pdDebug, NetworkMessage::region, DataDistribution::rootObject, Communications::sendMessage(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void associateRegion | ( | ObjectHandle | object,
|  | RegionHandle | region,
|  | std::vector< AttributeHandle > & | attr,
|  | int | nb,
|  | TypeException & | e |
| ) |  |  | throw (RegionNotKnown)

Definition at line 215 of file DataDistribution.cc.

References FederationManagement::_numero_federation, ObjectAttribute::associate(), DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_ASSOCIATE_REGION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, RootObject::getObject(), RootObject::getObjectAttribute(), RootObject::getRegion(), NetworkMessage::object, pdDebug, NetworkMessage::region, DataDistribution::rootObject, Communications::sendMessage(), NetworkMessage::setAHS(), Object::unassociate(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

ObjectHandle registerObject | ( | ObjectClassHandle | class_handle,
|  | const std::string | name,
|  | const std::vector< AttributeHandle > & | attrs,
|  | int | nb,
|  | const std::vector< RegionHandle > | regions,
|  | TypeException & | e |
| ) |  |  |

Definition at line 251 of file DataDistribution.cc.

References FederationManagement::_numero_federation, ObjectAttribute::associate(), certi::fedparser::attribute, DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_REGISTER_OBJECT, certi::e_NO_EXCEPTION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, RootObject::getObjectAttribute(), RootObject::getRegion(), NetworkMessage::objectClass, pdDebug, RootObject::registerObjectInstance(), DataDistribution::rootObject, Communications::sendMessage(), NetworkMessage::setAHS(), BasicMessage::setRegions(), NetworkMessage::setTag(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void unassociateRegion | ( | ObjectHandle | object,
|  | RegionHandle | region,
|  | TypeException & | e |
| ) |  |  | throw (ObjectNotKnown, InvalidRegionContext, RegionNotKnown)

Definition at line 293 of file DataDistribution.cc.

References FederationManagement::_numero_federation, DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_UNASSOCIATE_REGION, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, RootObject::getObject(), RootObject::getRegion(), NetworkMessage::object, pdDebug, NetworkMessage::region, DataDistribution::rootObject, Communications::sendMessage(), Object::unassociate(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void subscribe | ( | ObjectClassHandle | obj_class,
|  | RegionHandle | region,
|  | std::vector< AttributeHandle > & | attr,
|  | int | nb,
|  | TypeException & | e |
| ) |  |  | throw (RegionNotKnown)

Definition at line 320 of file DataDistribution.cc.

References FederationManagement::_numero_federation, DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_SUBSCRIBE_ATTRIBUTES, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, RootObject::getRegion(), NetworkMessage::objectClass, pdDebug, NetworkMessage::region, DataDistribution::rootObject, Communications::sendMessage(), NetworkMessage::setAHS(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void unsubscribeAttributes | ( | ObjectClassHandle | obj_class,
|  | RegionHandle | region,
|  | TypeException & | e |
| ) |  |  | throw (RegionNotKnown)

Definition at line 347 of file DataDistribution.cc.

References FederationManagement::_numero_federation, DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_UNSUBSCRIBE_ATTRIBUTES, FederationManagement::federate, NetworkMessage::federate, NetworkMessage::federation, DataDistribution::fm, RootObject::getRegion(), NetworkMessage::objectClass, pdDebug, NetworkMessage::region, DataDistribution::rootObject, Communications::sendMessage(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void subscribeInteraction | ( | InteractionClassHandle | int_class,
|  | RegionHandle | region,
|  | TypeException & | e |
| ) |  |  | throw (RegionNotKnown)

Definition at line 372 of file DataDistribution.cc.

References DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_SUBSCRIBE_INTERACTION, NetworkMessage::federate, RootObject::getRegion(), NetworkMessage::interactionClass, pdDebug, NetworkMessage::region, DataDistribution::rootObject, Communications::sendMessage(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

void unsubscribeInteraction | ( | InteractionClassHandle | int_class,
|  | RegionHandle | region,
|  | TypeException & | e |
| ) |  |  | throw (RegionNotKnown)

Definition at line 394 of file DataDistribution.cc.

References DataDistribution::comm, certi::rtia::D, NetworkMessage::DDM_UNSUBSCRIBE_INTERACTION, NetworkMessage::federate, RootObject::getRegion(), NetworkMessage::interactionClass, pdDebug, NetworkMessage::region, DataDistribution::rootObject, Communications::sendMessage(), and Communications::waitMessage().

Referenced by RTIA::chooseFederateProcessing().

Here is the call graph for this function:

## Member Data Documentation

RootObject* rootObject`[private]`

Definition at line 93 of file DataDistribution.hh.

Referenced by DataDistribution::associateRegion(), DataDistribution::createRegion(), DataDistribution::deleteRegion(), DataDistribution::getAttributeSpace(), DataDistribution::getDimensionHandle(), DataDistribution::getDimensionName(), DataDistribution::getInteractionSpace(), DataDistribution::getRoutingSpaceHandle(), DataDistribution::getRoutingSpaceName(), DataDistribution::modifyRegion(), DataDistribution::registerObject(), DataDistribution::subscribe(), DataDistribution::subscribeInteraction(), DataDistribution::unassociateRegion(), DataDistribution::unsubscribeAttributes(), and DataDistribution::unsubscribeInteraction().

FederationManagement* fm`[private]`

Definition at line 94 of file DataDistribution.hh.

Referenced by DataDistribution::associateRegion(), DataDistribution::createRegion(), DataDistribution::deleteRegion(), DataDistribution::modifyRegion(), DataDistribution::registerObject(), DataDistribution::subscribe(), DataDistribution::unassociateRegion(), and DataDistribution::unsubscribeAttributes().

Communications* comm`[private]`

Definition at line 95 of file DataDistribution.hh.

Referenced by DataDistribution::associateRegion(), DataDistribution::createRegion(), DataDistribution::deleteRegion(), DataDistribution::modifyRegion(), DataDistribution::registerObject(), DataDistribution::subscribe(), DataDistribution::subscribeInteraction(), DataDistribution::unassociateRegion(), DataDistribution::unsubscribeAttributes(), and DataDistribution::unsubscribeInteraction().

The documentation for this class was generated from the following files:

- DataDistribution.hh
- DataDistribution.cc